// New ViperGC Extreme undocumented features.

// Use ViperInit at boot, then ViperReadFlashDMA, then ViperExitCommandMode

// For quick access to the flash data. Size must be a multiple of 0x20 because
// EXI DMA size is always a multiple of 32B
ViperReadFlashDMA(unsigned char* buffer, int pos, int size)
{
    ViperWriteFlashAD(pos,0);
    ViperWriteFlashDOW(0,0,1);
    ViperSendCmd(0xd5, size>>16);
    ViperSendCmd(0xd5, size>>8);
    ViperSendCmd(0xd5, size);    
    ViperSendCmd(0xd7, 0);
    EXI_SR = 0x050;  
    EXI_DMA_MEM = (int)buffer; 
    EXI_DMA_LEN = size;
    EXI_CR = 3; 
    EXI_WAIT_EOT;
    EXI_SR = 0;    
    ViperWriteFlashDOW(0,1,1);
}
//check for VIPR at 0x812ffff0
void ViperGetVersionInit()
{
    viperVersion=((ViperReadSwitchAndLid()&0x40)>>6);        
}
// 0 = regular, 1 = extreme
unsigned int ViperGetVersion()
{
    return viperVersion;
}

//Flash File System details
//configuration/file system is at offset 0x1f0000.
#define CONFIG_CHEATS_BUFFERLEN 0xfa0
#define CONFIG_MAGIC 0x5b4d435d  // [mc]
#define CONFIG_MAGIC2 0x46465321 // FFS!
#define CONFIG_VERSION 0x01010000 
typedef struct {
    char name[32]; 
    int size;
    int flag;
    char sectors[32]; // sector mapping
} FLASH_FILE_TYPE;

typedef struct {
    int magic;   // magic word == CONFIG_MAGIC for good config
    int version;
    int default_action;
    int X_action;
    int reserved0; // for Y_action
    int audiofix; // was reserved1
    int lid_status;
    int auto_save; // save config each time something is changed?
    int cheats_nbgames;
    int cheats_enabled; // cheats enabled?
    int cheats_game_selected; // last/current game selected
    unsigned char cheats_buffer[CONFIG_CHEATS_BUFFERLEN]; // 3kb for cheats
    int cheats_buffer_size;
    int reserved1;
    int reserved2;
    int magic2; // yes, there is a filesystem! (0xfd0)
    int nbfiles;
    char sectors[32]; // 00 = empty, FF = full
    FLASH_FILE_TYPE files[CONFIG_FILE_NBSECTORS]; // 32 files max
    int crc1; 
} CONFIG_TYPE;

/*
// compute Checksum
int i;
config.crc1=0;
unsigned char* cfg=(unsigned char*)&config;
for (i=0;i<sizeof(config)-4;i++)
    config.crc1+=cfg[i];
*/